////////////////////////////////////////////////////////////////////// 
// merlin/TreeManager.h 
// (c) 2000-2006 Goncalo Abecasis
// 
// This file is distributed as part of the LAMP source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile LAMP.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Friday September 01, 2006
// 
 
#ifndef __TREEMANAGER_H__
#define __TREEMANAGER_H__

#include "MiniDeflate.h"

#ifdef _FILE_OFFSET_BITS
#  if _FILE_OFFSET_BITS == 64
#    define __HUGE_SWAP__
#  endif
#endif

#ifdef    __HUGE_SWAP__
#define   FILEINDEX_t fpos_t
#else
#define   FILEINDEX_t int
#endif

class BasicTree;

class TreePosition
   {
   public:
      FILEINDEX_t leaves;
      FILEINDEX_t skeleton;
   };


class TreeManager
   {
   public:
     // Swap file management functions
     //
     bool OpenFiles();        // Open file pointers
     void CloseFiles();       // Close files
     void Free();             // Discard contents and reuse swap file

     // This function may not work correctly in all systems
     double EstimateFileSize();

     // Routines for swapping tree in and out of memory
     FILEINDEX_t Pack(BasicTree & tree);
     FILEINDEX_t UnPack(BasicTree & tree);

     // Swap file pointers
     //
     FILE * skeleton;
     FILE * leaves;

     TreePosition  position;

     void GetPosition(TreePosition & position);
     void SetPosition(const TreePosition & position);

     void UpdatePosition()
        {
        GetPosition(position);
        }
   };

#endif


 
